#include "Matrix.h"

extern unsigned GMRes(const Matrix<double>&, double* const, double* const,
		      double&, const unsigned, unsigned&);
extern unsigned GMRes(const Matrix<dcomp>&, dcomp* const, dcomp* const,
		      double&, const unsigned, unsigned&);

extern unsigned BiCGStab(const Matrix<double>&, double* const,
			 double* const, double&, unsigned&);
extern unsigned BiCGStab(const Matrix<dcomp>&, dcomp* const,
			 dcomp* const, double&, unsigned&);

extern unsigned CG(const Matrix<double>&, double* const, double* const,
		   double&, unsigned&);
extern unsigned CG(const Matrix<dcomp>&, dcomp* const, dcomp* const,
		   double&, unsigned&);

extern unsigned MinRes(const Matrix<double>&, double* const, double* const,
		       double&, unsigned&);
